/*
 * File:	FMDialogs.cc
 * Purpose:	FileMaker dialogs (who woduv guesse'it);
 * Author:	Robert Roebling
 * Created:	1997
 * Copyright:   GPL
 */

#ifdef __GNUG__
#pragma implementation "FMDialogs.h"
#endif

#define Uses_wxPanel
#define Uses_wxCanvas
#define Uses_wxString
#define Uses_wxDialogBox
#define Uses_wxButton
#define Uses_wxText
#define Uses_wxCheckBox
#define Uses_wxRadioBox
#define Uses_wxMessage
#define Uses_wxTimer
#include "wx.h"

#include "WIN_listctrl.h"
#include "WIN_rawtext.h"
#include "FMDialogs.h"

//-----------------------------------------------------------------------------
// wxAboutDia
//-----------------------------------------------------------------------------

IMPLEMENT_DYNAMIC_CLASS(wxAboutDia,wxDialogBox);
  
wxAboutDia::wxAboutDia( wxFrame *parent ) :
  wxDialogBox( parent, "About FileMaker", TRUE, 180, 180, 520, 320, wxCAPTION | wxTRANSIENT )
{
  int w = 0;
  int h = 0;
  GetSize( &w, &h );

  int x = 10;
  int y = 10;
  int step = 20;

  wxFont *myFont = wxTheFontList->FindOrCreateFont( 12, wxROMAN, wxNORMAL, wxNORMAL );
  SetLabelFont( myFont );
  SetButtonFont( myFont );
  
  wxMessage *msg = new wxMessage( this, "FileMaker v0.1", 240, y );
  msg->Centre( wxHORIZONTAL );
  y += 2*step-10;
  
  msg = new wxMessage( this, "Written by Robert Roebling, 1997. Mail to:", x, y );
  y += step;
  msg = new wxMessage( this, "roebling@sun2.ruf.uni-freiburg.de", x+50, y );
  y += 2*step;
  
  msg = new wxMessage( this, "This program uses the wxXt v1.67 GUI-library written mainly by Markus Holzem. Mail to:", x, y );
  y += step;
  msg = new wxMessage( this, "mho@comnets.rwth-aachen.de", x+50, y );
  y += 2*step;

  msg = new wxMessage( this, "wxXt is based on the wxWindows GUI-library written mainly by Julian Smart. Mail to:", x, y );
  y += step;
  msg = new wxMessage( this, "julian.smart@ukonline.co.uk", x+50, y );
  y += 2*step;

  msg = new wxMessage( this, "wxXt Copyright L-GPL. FileMaker Copyright GPL. More information at:", x, y );
  y += step;
  msg = new wxMessage( this, "http://www-fs.informatik.uni-freiburg.de/~wxxt", x+50, y );
  
  m_closeButton = new wxButton( this, NULL, "Close", w-120, h-45, 85, 30 );
  
  Centre( wxVERTICAL | wxHORIZONTAL );
  Show( TRUE );
};

void wxAboutDia::OnCommand( wxWindow &win, wxCommandEvent &WXUNUSED(event) )
{
  if (&win == m_closeButton)
  {
    Show( FALSE );
    return;
  };
};

//-----------------------------------------------------------------------------
// wxMountDia
//-----------------------------------------------------------------------------

IMPLEMENT_DYNAMIC_CLASS(wxMountDia,wxDialogBox);
  
wxMountDia::wxMountDia( wxFrame *parent ) :
  wxDialogBox( parent, "Mount devices", TRUE, 180, 180, 480, 250 )
{
  int w = 0;
  int h = 0;
  GetSize( &w, &h );

  wxFont *myFont = wxTheFontList->FindOrCreateFont( 12, wxROMAN, wxNORMAL, wxNORMAL );
  SetLabelFont( myFont );
  SetButtonFont( myFont );
    
  m_closeButton = new wxButton( this, NULL, "Close", w-120, h-40, 85, 30 );
    
  m_mountList = new wxListCtrl( this, 8, 8, w-20, h-60, wxLC_REPORT | wxLC_SINGLE_SEL );
  m_mountList->InsertColumn( 0, "Device", wxLIST_FORMAT_LEFT, 100 );
  m_mountList->InsertColumn( 1, "Mounted", wxLIST_FORMAT_LEFT, 60 );
  m_mountList->InsertColumn( 2, "Mount dir", wxLIST_FORMAT_LEFT, 100 );
  m_mountList->InsertColumn( 3, "Status", wxLIST_FORMAT_LEFT, 60 );
  m_mountList->InsertColumn( 5, "Options", wxLIST_FORMAT_LEFT, 50 );

  FillMountList();
      
  m_mountButton = new wxButton( this, NULL, "Mount", 30, h-45, 80, 30 );
  m_unmountButton = new wxButton( this, NULL, "Unmount", 130, h-45, 80, 30 );

  Centre( wxVERTICAL | wxHORIZONTAL );
  Show( TRUE );
};

wxMountDia::~wxMountDia()
{
};

void wxMountDia::OnCommand( wxWindow &win, wxCommandEvent &WXUNUSED(event) )
{
  if (&win == m_closeButton)
  {
    Show( FALSE );
    return;
  };
};

void wxMountDia::OnSize( int x, int y )
{
  int h = y;
  int w = x;
  m_mountList->SetSize( 8, 8, w-20, h-60 );
  m_mountButton->SetSize( 30, h-45, 80, 30 );
  m_unmountButton->SetSize( 130, h-45, 80, 30 );
  m_closeButton->SetSize( w-120, h-45, 80, 30 );
};

void wxMountDia::FillMountList( void )
{
  m_mountList->InsertItem( 0, "/dev/cdrom" );
  m_mountList->SetItem( 0, 1, "yes" );
  m_mountList->SetItem( 0, 2, "/mnt/cdrom" );
  m_mountList->SetItem( 0, 3, "read only" );
  m_mountList->SetItem( 0, 4, "0" );
  
  m_mountList->InsertItem( 0, "/dev/fd0" );
  m_mountList->SetItem( 0, 1, "yes" );
  m_mountList->SetItem( 0, 2, "/mnt/dos_a" );
  m_mountList->SetItem( 0, 3, "read/write" );
  m_mountList->SetItem( 0, 4, "0" );
  
  m_mountList->InsertItem( 0, "/dev/fd1" );
  m_mountList->SetItem( 0, 1, "no" );
  m_mountList->SetItem( 0, 2, "/mnt/dos_b" );
  m_mountList->SetItem( 0, 3, "read/write" );
  m_mountList->SetItem( 0, 4, "0" );
  
  m_mountList->RealizeChanges();
};

//-----------------------------------------------------------------------------
// wxCopyMoveDia
//-----------------------------------------------------------------------------

IMPLEMENT_DYNAMIC_CLASS(wxCopyMoveDia,wxDialogBox);
  
wxCopyMoveDia::wxCopyMoveDia( wxFrame *parent, int n, char **files, char *destDir ) :
  wxDialogBox( parent, "Copy or move files", TRUE, 180, 180, 420, 170 )
{
  m_count = n;
  m_files = files;
  m_destDir = destDir;

  int w = 0;
  int h = 0;
  GetSize( &w, &h );
  
  wxFont *myFont = wxTheFontList->FindOrCreateFont( 12, wxROMAN, wxNORMAL, wxNORMAL );
  SetLabelFont( myFont );
  SetButtonFont( myFont );
  
  m_cancelButton = new wxButton( this, NULL, "Cancel", w-120, h-45, 85, 30 );
    
  m_generalMsg = new wxMessage( this, "Copy or move files to:", 10, 8 );

    /*
    wxMessage    *m_filesMsg;
    */
    
  m_dest = new wxRawText( this, m_destDir, 10, 40, w-30, 30 );
  
  m_recursiv = new wxCheckBox( this, NULL, "Recurse subdirectories", 10, 80 );
  m_followLinks = new wxCheckBox( this, NULL, "Follow links", 200, 80 );
    
  m_moveButton = new wxButton( this, NULL, "Move", 130, h-45, 80, 30 );
  m_copyButton = new wxButton( this, NULL, "Copy", 30, h-45, 80, 30 );

  Centre( wxVERTICAL | wxHORIZONTAL );
  Show( TRUE );
};

void wxCopyMoveDia::OnCommand( wxWindow &win, wxCommandEvent &WXUNUSED(event) )
{
  if (&win == m_cancelButton)
  {
    Show( FALSE );
    return;
  };
};

void wxCopyMoveDia::OnSize( int x, int y )
{
  int h = y;
  int w = x;
  m_moveButton->SetSize( 30, h-45, 80, 30 );
  m_copyButton->SetSize( 130, h-45, 80, 30 );
  m_cancelButton->SetSize( w-120, h-45, 80, 30 );
};

void wxCopyMoveDia::DoCopyMove( void )
{
};

//-----------------------------------------------------------------------------
// wxFindDia
//-----------------------------------------------------------------------------

IMPLEMENT_DYNAMIC_CLASS(wxFindDia,wxDialogBox);
  
wxFindDia::wxFindDia( wxFrame *parent, char *startDir ) :
  wxDialogBox( parent, "Search for files", TRUE, 20, 20, 580, 400 )
{
  m_startDir = startDir;

  int w = 0;
  int h = 0;
  GetSize( &w, &h );

  wxFont *myFont = wxTheFontList->FindOrCreateFont( 12, wxROMAN, wxNORMAL, wxNORMAL );
  SetLabelFont( myFont );
  SetButtonFont( myFont );
  
  char *radio_strings1[3] = { 
    "Exact day", 
    "Older than",
    "Younger than" };
  m_date = new wxRadioBox( this, NULL, NULL, 10, 10, 100, -1, 3, radio_strings1, 3, wxVERTICAL );
  m_dateTxt = new wxRawText( this, "11.7.97", 8, 92, 105, 30 );
  
  char *radio_strings2[2] = { 
    "Bigger than", 
    "Smaller than" };
  m_size = new wxRadioBox( this, NULL, NULL, 10, 160, 100, -1, 2, radio_strings2, 2, wxVERTICAL );
  m_sizeTxt = new wxRawText( this, "0", 8, 220, 105, 30 );
  
  m_contentsMsg = new wxMessage( this, "Search string", 10, h-130, 90, 25 );
  m_contents = new wxRawText( this, "Test", 100, h-130, w-300, 30 );
  
  m_recursiv = new wxCheckBox( this, NULL, "Recurse subdirectories", w-200, h-130 );
  
  m_startMsg = new wxMessage( this, "Search dir", 10, h-100, 90, 25 );
  m_startTxt = new wxRawText( this, startDir, 100, h-100, w-300, 28 );
  
  m_maskMsg = new wxMessage( this, "File mask", w-180, h-100, 80, 25 );
  m_maskTxt = new wxRawText( this, "*", w-100, h-100, 80, 28 );
    
  m_startButton = new wxButton( this, NULL, "Start", 20, h-45, 80, 30 );
  m_stopButton = new wxButton( this, NULL, "Stop", 120, h-45, 80, 30 );
  m_gotoButton = new wxButton( this, NULL, "Go to", 220, h-45, 80, 30 );
  m_resetButton = new wxButton( this, NULL, "Reset", 320, h-45, 80, 30 );

  m_closeButton = new wxButton( this, NULL, "Close", w-120, h-45, 85, 30 );
  
  m_fileList = new wxListCtrl( this, 140, 8, w-150, h-150, wxLC_REPORT );
  m_fileList->InsertColumn( 0, "File", wxLIST_FORMAT_LEFT, 90 );
  m_fileList->InsertColumn( 1, "Directory", wxLIST_FORMAT_LEFT, 180 );
  m_fileList->InsertColumn( 2, "Date", wxLIST_FORMAT_LEFT, 60 );
  m_fileList->InsertColumn( 3, "Size", wxLIST_FORMAT_LEFT, 60 );
  m_fileList->InsertItem( 0, "test.txt" );
  m_fileList->SetItem( 0, 1, "/home/Robert" );
  m_fileList->RealizeChanges();
  
  Centre( wxVERTICAL | wxHORIZONTAL );
  Show( TRUE );
};

void wxFindDia::OnCommand( wxWindow &win, wxCommandEvent &WXUNUSED(event) )
{
  if (&win == m_closeButton)
  {
    Show( FALSE );
    return;
  };
};

void wxFindDia::OnSize( int x, int y )
{
  int h = y;
  int w = x;
  m_fileList->SetSize( 140, 8, w-150, h-150 );
  
  m_contentsMsg->SetSize( 25, h-130, 75, 30 );
  m_contents->SetSize( 100, h-130, w-300, 30 );
  
  m_startMsg->SetSize( 40, h-100, 60, 30 );
  m_startTxt->SetSize( 100, h-100, w-300, 30 );
  
  m_maskMsg->SetSize( w-180, h-100, 60, 30 );
  m_maskTxt->SetSize( w-120, h-100, 80, 30 );
  
  m_recursiv->SetSize( w-180, h-130, -1, -1, wxSIZE_USE_EXISTING );
  m_startButton->SetSize( 20, h-45, 80, 30 );
  m_stopButton->SetSize( 120, h-45, 80, 30 );
  m_gotoButton->SetSize( 220, h-45, 80, 30 );
  m_resetButton->SetSize( 320, h-45, 80, 30 );
  m_closeButton->SetSize( w-120, h-45, 80, 30 );
};

void wxFindDia::DoSearch( void )
{
};


