/*
 * File:	FMDialogs.h
 * Author:      Robert Roebling
 * Created:	1997
 * Copyright:   GPL
 */

#ifndef __FMDIALOGSH__
#define __FMDIALOGSH__

#ifdef __GNUG__
#pragma interface
#endif

//-----------------------------------------------------------------------------
// classes
//-----------------------------------------------------------------------------

// in order of importance..

class wxAboutDia;
class wxMountDia;
class wxCopyMoveDia;
class wxFindDia;
class wxSymlinkDia;
class wxDeleteDia;
class wxTGZDia;
class wxExtensionsDia;
class wxSortDia;
class wxChangePermissions;
class wxLPDia;
class wxProcessDia;
class wxDebianDia;
class wxUserDia;
class wxRPMDia;
class wxFTPDia;

//-----------------------------------------------------------------------------
// wxAboutDia
//-----------------------------------------------------------------------------

class wxAboutDia : public wxDialogBox
{
  DECLARE_DYNAMIC_CLASS(wxAboutDia);
  
  private:

    wxButton     *m_closeButton;
  
  public:
  
    wxAboutDia() : wxDialogBox() {};
    wxAboutDia( wxFrame *parent );
    void OnCommand( wxWindow &win, wxCommandEvent &event );
};

//-----------------------------------------------------------------------------
// wxMountDia
//-----------------------------------------------------------------------------

class wxMountDia : public wxDialogBox
{
  DECLARE_DYNAMIC_CLASS(wxMountDia);
  
  private:
  
    wxButton     *m_closeButton;
    wxListCtrl   *m_mountList;
    wxButton     *m_mountButton;
    wxButton     *m_unmountButton;
    wxButton     *m_editFtabButton;
  
  public:
  
    wxMountDia() : wxDialogBox() {};
    wxMountDia( wxFrame *parent );
    ~wxMountDia();
    void OnCommand( wxWindow &win, wxCommandEvent &event );
    void OnSize( int x, int y );
    void FillMountList( void );
};

//-----------------------------------------------------------------------------
// wxCopyMoveDia
//-----------------------------------------------------------------------------

class wxCopyMoveDia : public wxDialogBox
{
  DECLARE_DYNAMIC_CLASS(wxCopyMoveDia);
  
  private:
  
    wxButton     *m_cancelButton;
    wxMessage    *m_generalMsg;
    wxMessage    *m_filesMsg;
    wxRawText    *m_dest;
    wxCheckBox   *m_recursiv;
    wxCheckBox   *m_followLinks;
    wxButton     *m_copyButton;
    wxButton     *m_moveButton;
    int           m_count;
    char        **m_files;
    wxString      m_destDir;
  
  public:
  
    wxCopyMoveDia() : wxDialogBox() {};
    wxCopyMoveDia( wxFrame *parent, int n, char **files, char *destDir );
    void OnCommand( wxWindow &win, wxCommandEvent &event );
    void OnSize( int x, int y );
    void DoCopyMove( void );
};

//-----------------------------------------------------------------------------
// wxFindDia
//-----------------------------------------------------------------------------

class wxFindDia : public wxDialogBox
{
  DECLARE_DYNAMIC_CLASS(wxFindDia);
  
  private:
  
    wxButton     *m_closeButton;
    wxListCtrl   *m_fileList;
    wxMessage    *m_startMsg;
    wxRawText    *m_startTxt;
    wxMessage    *m_maskMsg;
    wxRawText    *m_maskTxt;
    wxMessage    *m_contentsMsg;
    wxRawText    *m_contents;
    wxRadioBox   *m_size;
    wxRawText    *m_sizeTxt;
    wxRadioBox   *m_date;
    wxRawText    *m_dateTxt;
    wxCheckBox   *m_recursiv;
    wxButton     *m_startButton;
    wxButton     *m_stopButton;
    wxButton     *m_gotoButton;
    wxButton     *m_resetButton;
    wxString      m_startDir;
  
  public:
  
    wxFindDia() : wxDialogBox() {};
    wxFindDia( wxFrame *parent, char *startDir );
    void OnCommand( wxWindow &win, wxCommandEvent &event );
    void OnSize( int x, int y );
    void DoSearch( void );
};

#endif // FMDIALOGS
