/*
 * Program: FileMaker
 * 
 * Purpose: file manager to demonstrate a few new classes written 
 * for wxXt: wxTreeCtrl, wxDirTree, wxListCtrl, wxFileList, wxDragCanvas
 *
 * Author: Robert Roebling
 *
 * Copyright: (C) 1997, GNU (Robert Roebling)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef FileMaker_h
#define FileMaker_h

#ifdef __GNUG__
#pragma interface
#endif

//-----------------------------------------------------------------------------
// derived classes
//-----------------------------------------------------------------------------

class wxLiveApp;
class wxLiveFrame;
class wxLivePanel;

//-----------------------------------------------------------------------------
// wxLiveApp
//-----------------------------------------------------------------------------

class wxLiveApp: public wxApp 
{
  public:
  
    wxImageList *imageList;
    
    wxLiveApp(void):  wxApp() { wx_class = "live"; };
    wxFrame* OnInit(void);
    void MakeDisplay( void );
    int OnExit(void);
};

//-----------------------------------------------------------------------------
// wxLiveFrame
//-----------------------------------------------------------------------------

class wxLiveFrame: public wxDecoratedFrame 
//class wxLiveFrame: public wxFrame 
{
  DECLARE_DYNAMIC_CLASS(wxLiveFrame);

  public:
    wxLiveFrame() : wxDecoratedFrame() {};
//    wxLiveFrame() : wxFrame() {};
    wxLiveFrame( wxFrame *f, char *title, int x=-1, int y=-1, int w=-1, int h=-1) : 
      wxDecoratedFrame( f, title, x, y, w, h ) { };
//      wxFrame( f, title, x, y, w, h ) { };
    void OnMenuCommand(int id);
    void DoCopy( void );
    void DoDelete( void );
    void DoMove( void );
    void DoEditSymlink( void );
    void DoCreateSymlink( void );
    void DoCreateDir( void );
    void DoChangePerm( void );
    void DoFindFile( void );
    void DoMount( void );
    Bool OnClose(void);
    void DoResize( void );
    void OnDecoratedSize( int x, int y, int w, int h );
};

//-----------------------------------------------------------------------------
// wxLivePanel
//-----------------------------------------------------------------------------

class wxLivePanel: public wxPanel 
{
  public:
    wxLivePanel( wxFrame *parent, int x=-1, int y=-1,
      int width=-1, int height=-1, int style=wxNO_DC|wxBORDER, char *name="wxLivePanel" );
    void OnCommand( wxWindow &win, wxCommandEvent &event );
    void OnDefaultAction( wxItem *item );
//    void ChangePage( wxLivePage* p );
};

#endif // FileMaker_h
