/*
 * Copyright: (C) 1997, GNU (Robert Roebling)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DirTree_h
#define DirTree_h

#ifdef __GNUG__
#pragma interface
#endif

#include "WIN_treectrl.h"
#include "WIN_filelist.h"

//-----------------------------------------------------------------------------
// class
//-----------------------------------------------------------------------------

class wxDirBranch;

//-----------------------------------------------------------------------------
//  wxDirBranch
//-----------------------------------------------------------------------------

class wxDirBranch : public wxVirtualBranch
{
  DECLARE_DYNAMIC_CLASS(wxDirBranch)

  private:
    wxString     dirName,bName;
    wxFileCtrl  *files;
    Bool         m_showHidden;

  public:
    wxDirBranch( void ) 
      : wxVirtualBranch() {}; 
    wxDirBranch( char *dir, wxFileCtrl *f = NULL ); 
    char *GetName( void );
    char *GetDirName( void );
    void Expand( void );
    void Activated( void );
    int CompareTo( wxVirtualBranch *b );
};

//-----------------------------------------------------------------------------
//  wxDirTree
//-----------------------------------------------------------------------------

class wxDirTree : public wxVirtualTree 
{
  DECLARE_DYNAMIC_CLASS(wxDirTree)
  
  public:
    wxDirTree( void ) : wxVirtualTree() {};
    wxDirTree( wxPanel *p, int x=-1, int y=-1, int width=-1, int height=-1,
	     long style=0, Constdata char *name= "wxDirTree" );
    void OnDropFiles( int n, char **files, int y, int y );
};

#endif // liveTREE_h
